<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Доступы
        <div class="card-header-actions">
          <button  class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="items.length" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

  </b-container>
</template>

<script>
import Api from '@/services/Api'

export default {
  name: 'Positions',
  components: {

  },
  props: {
    caption: {
      type: String,
      default: 'Должности'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      items: [],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      modalInfo: {
        id: '',
        name: ''
      },
      addedModal: {
        name: ''
      },
    }
  },
  computed: {
    disabled () {
      if (this.addedModal.name.length > 0) {
        return false
      } else {
        return true
      }
    }
  },
  methods: {
    getPositions () {
      Api().get('getpositions').then(response => {
        this.items = response.data
      })
    },
    adding (e) {
      Api().post('addposition', this.addedModal).then(response => {
        this.resetModal()
        window.location.reload()
      })
    },
    edit (e) {
      Api().post('editposition', this.modalInfo).then(response => {
        this.resetModal()
        window.location.reload()
      })
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deleteposition', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    resetModal () {
      this.addedModal.name = ''
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  },
  beforeMount () {
    this.getPositions()
  }
}
</script>
